; #########################################################################

    ; --------------------------------------
    ; This procedure was written by UsAr
    ; --------------------------------------

      .586
      .model flat, stdcall  ; 32 bit memory model
      option casemap :none  ; case sensitive

      include   windows.inc
      include   my.mac
      include_  kernel32
      include   mylib.inc

    .code


; #########################################################################

ADDCODE struc
    lpFileName  dd ?
    lpData      dd ?
    dwDataSize  dd ?
    lpMem       dd ?
    lpNewData   dd ?
ADDCODE ends

AddDataToLastSection proc pAddData:DWORD
local hFile:DWORD,pMem:DWORD,SizeRW:DWORD,dwFileSize:DWORD,dwSectionAlignment:DWORD,dwFileAlignment:DWORD

    pushad
    mov     esi,pAddData
    assume  esi:ptr ADDCODE
    mov     hFile,FUNC(CreateFile,[esi].lpFileName,GENERIC_READ or GENERIC_WRITE,FILE_SHARE_READ or FILE_SHARE_WRITE,0,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,0)

    mov     dwFileSize,FUNC(GetFileSize,hFile,0)
    mov     pMem,FUNC(GlobalAlloc,GMEM_FIXED or GMEM_ZEROINIT,1000h)
    invoke  SetFilePointer,hFile,0,0,FILE_BEGIN
    mov     ecx,dwFileSize
    cmp     ecx,1000h
    jb      @F
    mov     ecx,1000h
@@: invoke  ReadFile,hFile,pMem,ecx,addr SizeRW,0
    mov     edi,pMem
    add     edi,[edi+3Ch]
    invoke  GetLastPhisicalSection,pMem
    mov     ecx,[eax].IMAGE_SECTION_HEADER.VirtualAddress
    add     ecx,[eax].IMAGE_SECTION_HEADER.Misc.VirtualSize
    add     ecx,[esi].dwDataSize
    mov     eax,ecx
    m2m     dwFileAlignment,[edi].IMAGE_NT_HEADERS.OptionalHeader.FileAlignment
    m2m     dwSectionAlignment,[edi].IMAGE_NT_HEADERS.OptionalHeader.SectionAlignment

    invoke  GetLastPhisicalSection,pMem
    mov     edi,eax
    mov     eax,[edi].IMAGE_SECTION_HEADER.SizeOfRawData
    add     eax,[esi].dwDataSize
    invoke  AlignUp,eax,dwFileAlignment
    mov     [edi].IMAGE_SECTION_HEADER.SizeOfRawData,eax

    mov     eax,[edi].IMAGE_SECTION_HEADER.Misc.VirtualSize
    add     eax,[esi].dwDataSize
    invoke  AlignUp,eax,dwSectionAlignment
    mov     [edi].IMAGE_SECTION_HEADER.Misc.VirtualSize,eax
    .if eax < [edi].IMAGE_SECTION_HEADER.SizeOfRawData
        mov     eax,[edi].IMAGE_SECTION_HEADER.SizeOfRawData
        invoke  AlignUp,eax,dwSectionAlignment
        mov     [edi].IMAGE_SECTION_HEADER.Misc.VirtualSize,eax
    .endif
    mov     eax,[edi].IMAGE_SECTION_HEADER.VirtualAddress
    add     eax,[edi].IMAGE_SECTION_HEADER.Misc.VirtualSize
    invoke  AlignUp,eax,dwSectionAlignment
    mov     edi,pMem
    add     edi,[edi+3Ch]
    mov     [edi].IMAGE_NT_HEADERS.OptionalHeader.SizeOfImage,eax

    mov     ecx,dwFileSize
    cmp     ecx,1000h
    jb      @F
    mov     ecx,1000h
@@: push    ecx
    invoke  SetFilePointer,hFile,0,0,FILE_BEGIN
    pop     ecx
    invoke  WriteFile,hFile,pMem,ecx,addr SizeRW,0
    invoke  SetFilePointer,hFile,0,0,FILE_END
    invoke  WriteFile,hFile,[esi].lpData,[esi].dwDataSize,addr SizeRW,0

    mov     edi,pMem
    add     edi,[edi+3Ch]
    mov     eax,[esi].dwDataSize
    invoke  AlignUp,eax,dwFileAlignment
    sub     eax,[esi].dwDataSize

    .if eax
        push    eax
        invoke  GlobalAlloc,GMEM_FIXED or GMEM_ZEROINIT,eax
        pop     ecx
        mov     edx,eax
        push    ecx
    @@: mov     bpt [eax],0
        loop    @B
        pop     ecx
        push    edx
        invoke  WriteFile,hFile,edx,ecx,addr SizeRW,0
        call    GlobalFree
    .endif

    invoke  GlobalFree,pMem
    invoke  CloseHandle,hFile

    popad
    return
AddDataToLastSection endp

; #########################################################################

end
