; #########################################################################

    ; --------------------------------------
    ; This procedure was written by UsAr
    ; --------------------------------------

      .586
      .model flat, stdcall  ; 32 bit memory model
      option casemap :none  ; case sensitive

      include   windows.inc
      include   my.mac
      include   mylib.inc

    FindFirstVirtualSection    PROTO :DWORD,:DWORD,:DWORD

    .code

; #########################################################################
FIND_SECTION struc
    lpSection           DWORD ?
    dwTmp               DWORD ?
FIND_SECTION ends

GetFirstVirtualSection proc lpImage:DWORD
local findSection:FIND_SECTION

    mov     findSection.dwTmp,-1
    invoke  SectionsWorks,lpImage,ofs FindFirstVirtualSection,addr findSection
    mov     eax,findSection.lpSection
    ret
GetFirstVirtualSection endp

FindFirstVirtualSection proc uses esi edi eax lpImage:DWORD,lpSection:DWORD,lParam:DWORD
    mov     edi,lParam
    assume  edi:ptr FIND_SECTION
    mov     esi,lpSection
    assume  esi:ptr IMAGE_SECTION_HEADER
    mov     eax,[esi].VirtualAddress
    cmp     eax,[edi].dwTmp
    ja      @F
    mov     [edi].dwTmp,eax
    mov     [edi].lpSection,esi
@@: ret
FindFirstVirtualSection endp

; #########################################################################

end
