; #########################################################################

    ; --------------------------------------
    ; This procedure was written by UsAr
    ; --------------------------------------

      .586
      .model flat, stdcall  ; 32 bit memory model
      option casemap :none  ; case sensitive

      include   windows.inc
      include   my.mac
      include   mylib.inc

    .code

; #########################################################################

GetSectionByVA proc uses edi edx ecx lpImage:DWORD,dwEntryPoint:DWORD
local FileAlignment:DWORD,SectionAlignment:DWORD
    mov     edi,lpImage
    assume  edi:ptr IMAGE_DOS_HEADER
    add     edi,[edi].e_lfanew
    assume  edi:ptr IMAGE_NT_HEADERS
    m2m     FileAlignment,[edi].OptionalHeader.FileAlignment
    m2m     SectionAlignment,[edi].OptionalHeader.SectionAlignment

    movzx   edx,wpt [edi].FileHeader.NumberOfSections
    movzx   eax,wpt [edi].FileHeader.SizeOfOptionalHeader
    lea     edi,[edi + eax].OptionalHeader
    assume  edi:ptr IMAGE_SECTION_HEADER

nextsection:
    mov     ecx,FUNC(AlignUp,[edi].Misc.VirtualSize,SectionAlignment)
    invoke  AlignDown,[edi].VirtualAddress,SectionAlignment
    invoke  IfInRange,dwEntryPoint,eax,ecx
    test    eax,eax
    jz      @notcode
    mov     eax,edi
    ret

@notcode:
    add     edi,sof IMAGE_SECTION_HEADER
    dec     edx
    jne     nextsection

    xor     eax,eax
    ret
GetSectionByVA endp

; #########################################################################

end
