;@goto end

;HHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHH;
;
;                                         YZPack 1.1
;
; YZPack - Simple OpenSource PE Packer writen on MASM32
; based on LZMA compression method (library from packman)
;                                                                                 (c) UsAr
;HHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHH;


.486
.model flat, stdcall
option casemap :none

;HHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHH;

    include     windows.inc
    include     <inc\my.mac>
    include     <inc\TEB.inc>
    include_    user32
    include_    GDI32
    include_    comdlg32
    include_    kernel32
    include_    <MyLib\mylib>
    include_    <lzma\lzma>

    ShowError           PROTO :DWORD,:DWORD,:DWORD
    PERebuild           PROTO :DWORD,:DWORD
    MapFile             PROTO :DWORD,:DWORD
    PEPack              PROTO :DWORD,:DWORD
    PackSection         PROTO :DWORD,:DWORD,:DWORD
    CopyToLoader        PROTO :DWORD,:DWORD
    CopyToResMem        PROTO :DWORD,:DWORD
    AddUnpackToLoader   PROTO :DWORD
    NullProc            PROTO
    AssembleIT          PROTO :DWORD,:DWORD
    MergeSections       PROTO :DWORD,:DWORD
    EnumResDir          PROTO :DWORD
    GetRes              PROTO :DWORD
    fsize               PROTO :DWORD

;HHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHH;

PACKSEC struc
    lpSec       dd ?
    dwSize      dd ?
    lpMem       dd ?
    dwTrueSize  dd ?
PACKSEC ends

.data?
    szBuffer1       db 1024 dup (?)
    szBuffer2       db 1024 dup (?)
    ofn             OPENFILENAME <>
    dwLoaderSize    dd ?
    lpLoader        dd ?
    nSec            dd ?
    PackSections    PACKSEC 10 dup (<?>)
    TLS_BACKUP      IMAGE_TLS_DIRECTORY32 <>
    bTLS            db ?
    lpIcon          dd ?
    lpIconGroup     dd ?
    dwPtr           dd ?
    tmpirdir        IMAGE_RESOURCE_DIRECTORY <>
    tmpirdire       IMAGE_RESOURCE_DIRECTORY_ENTRY <>
    tmpirdatae      IMAGE_RESOURCE_DATA_ENTRY <>
    dwIcons         dd ?
    lpResMem        dd ?
    IconVA          dd ?
    tmpFlags        dd ?

    FLAG_RELOC      equ 1
    FLAG_DLL        equ 2

;HHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHH;

.data
    szFilter        db "PE Files (*.exe, *.dll)",0
    szDefExt        db "*.exe;*.dll",0
                    db "All Files (*.*)",0,"*.*",0,0

    icongroup       db 000h,000h,001h,000h
                    db 001h,000h,010h,010h
                    db 000h,000h,001h,000h
                    db 008h,000h
    iconsize        dd 0568h
                    db 001h,000h

;HHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHH;

.code
start:

    mov     ofn.lStructSize,sof OPENFILENAME
    mov     ofn.lpstrFilter,ofs szFilter
    mov     ofn.lpstrFile,ofs szBuffer1
    mov     ofn.nMaxFile,sof szBuffer1
    mov     ofn.lpstrTitle,$CT0("Please Choose the Input File")
    mov     ofn.lpstrDefExt,ofs szDefExt
    mov     ofn.Flags,OFN_FILEMUSTEXIST or OFN_HIDEREADONLY or OFN_EXPLORER or OFN_LONGNAMES
    invoke  GetOpenFileName,ofs ofn
    cmp     bpt ds:[szBuffer1],0
    jz      @ExitProcess

    mov     ofn.lStructSize,sof OPENFILENAME
    mov     ofn.lpstrFilter,ofs szFilter
    mov     ofn.lpstrFile,ofs szBuffer2
    mov     ofn.nMaxFile,sof szBuffer2
    mov     ofn.lpstrTitle,$CT0("Please Choose the Output File")
    mov     ofn.lpstrDefExt,ofs szDefExt
    mov     ofn.Flags,OFN_OVERWRITEPROMPT or OFN_HIDEREADONLY or OFN_EXPLORER or OFN_LONGNAMES
    invoke  GetSaveFileName,ofs ofn
    cmp     bpt ds:[szBuffer2],0
    jz      @ExitProcess

    set     dwSize1,FUNC(fsize,ofs szBuffer1)
    InstSehFrame ofs @UnknownError
    invoke  PEPack,ofs szBuffer1,ofs szBuffer2
    KillSehFrame
    set     dwSize2,FUNC(fsize,ofs szBuffer2)
    xor     edx,edx
    mov     eax,dwSize2
    imul    eax,100
    mov     ebx,dwSize1
    div     ebx
    invoke  wsprintf,ofs szBuffer1,$CT0("File packed successfuly\n%d -\] %d (%d%%)"),dwSize1,dwSize2,eax
    invoke  MessageBox,0,ofs szBuffer1,$CT0("YZPack 1.0 by UsAr"),MB_OK
@ExitProcess:
    invoke  ExitProcess,0

@UnknownError:
    scall   ShowError,$CT0("Unknown Error"),eax,ofs @ExitProcess
    jmp     @ExitProcess

;HHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHH;

ADDCODE struc
    lpFileName  dd ?
    lpData      dd ?
    dwDataSize  dd ?
    lpMem       dd ?
    lpNewData   dd ?
ADDCODE ends

;HHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHH;

fsize proc uses esi lpFileName:DWORD
    mov     esi,FUNC(CreateFile,lpFileName,GENERIC_READ,FILE_SHARE_READ,0,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,0)
    invoke  GetFileSize,esi,0
    push    eax
    invoke  CloseHandle,esi
    pop     eax
    return
fsize endp

;HHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHH;

PEPack proc lpFileName1:DWORD,lpFileName2:DWORD
local pMem:DWORD,dwFileSize:DWORD,sAddData:ADDCODE,dwExFileSize:DWORD

    invoke  MergeSections,lpFileName1,lpFileName2

    mov     pMem,FUNC(MapFile,lpFileName2,addr dwFileSize)
    m2m     dwExFileSize,dwFileSize
    add     dwExFileSize,1000h
    mov     edi,pMem
    add     edi,[edi+3Ch]
    mov     eax,[edi].IMAGE_NT_HEADERS.OptionalHeader.ImageBase
    mov     dpt [@@@@ImageBase],eax
    add     eax,[edi].IMAGE_NT_HEADERS.OptionalHeader.AddressOfEntryPoint
    mov     dpt [@@@@oep],eax
    m2m     dpt [@@@@ImportDerectorySIZE],[edi].IMAGE_NT_HEADERS.OptionalHeader.DataDirectory[(IMAGE_DIR_IMPORT)].isize
    mov     eax,[edi].IMAGE_NT_HEADERS.OptionalHeader.DataDirectory[(IMAGE_DIR_IMPORT)].VirtualAddress
    add     eax,dpt [@@@@ImageBase]
    mov     dpt [@@@@ImportDerectoryVA],eax
    add     dpt [@@@@ImportDerectorySIZE],eax
    xor     eax,eax
    mov     [edi].IMAGE_NT_HEADERS.OptionalHeader.DataDirectory[(IMAGE_DIR_IMPORT)].isize,eax
    mov     [edi].IMAGE_NT_HEADERS.OptionalHeader.DataDirectory[(IMAGE_DIR_IMPORT)].VirtualAddress,eax
    mov     [edi].IMAGE_NT_HEADERS.OptionalHeader.DataDirectory[(IMAGE_DIR_IAT)].isize,eax
    mov     [edi].IMAGE_NT_HEADERS.OptionalHeader.DataDirectory[(IMAGE_DIR_IAT)].VirtualAddress,eax
    mov     [edi].IMAGE_NT_HEADERS.OptionalHeader.DataDirectory[(IMAGE_DIR_BOUND_IMPORT)].VirtualAddress,eax
    mov     [edi].IMAGE_NT_HEADERS.OptionalHeader.DataDirectory[(IMAGE_DIR_BOUND_IMPORT)].isize,eax
    mov     [edi].IMAGE_NT_HEADERS.OptionalHeader.DataDirectory[(IMAGE_DIR_LOAD_CONFIG)].VirtualAddress,eax
    mov     [edi].IMAGE_NT_HEADERS.OptionalHeader.DataDirectory[(IMAGE_DIR_LOAD_CONFIG)].isize,eax
    mov     [edi].IMAGE_NT_HEADERS.OptionalHeader.DataDirectory[(IMAGE_DIR_DEBUG)].isize,eax
    mov     [edi].IMAGE_NT_HEADERS.OptionalHeader.DataDirectory[(IMAGE_DIR_DEBUG)].VirtualAddress,eax
    mov     [edi].IMAGE_NT_HEADERS.OptionalHeader.DataDirectory[(IMAGE_DIR_BASERELOC)].VirtualAddress,eax
    mov     [edi].IMAGE_NT_HEADERS.OptionalHeader.DataDirectory[(IMAGE_DIR_BASERELOC)].isize,eax
    mov     ecx,[edi].IMAGE_NT_HEADERS.OptionalHeader.DataDirectory[(IMAGE_DIR_TLS)].VirtualAddress
    .IF ecx
        inc     bTLS
        invoke  RVA2Offset,pMem,ecx
        add     eax,pMem
        move    ofs TLS_BACKUP,eax,sof IMAGE_TLS_DIRECTORY32
    .ENDIF
    mov     esi,[edi].IMAGE_NT_HEADERS.OptionalHeader.DataDirectory[(IMAGE_DIR_RESOURCE)].VirtualAddress
    mov     dpt [@@@@ResVA],esi
    mov     eax,[edi].IMAGE_NT_HEADERS.OptionalHeader.DataDirectory[(IMAGE_DIR_RESOURCE)].isize
    set     dwResSize,eax
    mov     dpt [@@@@ResSIZE],eax
    add     esi,pMem
    set     pRes,esi
    .if eax
        invoke  EnumResDir,esi
    .endif
    invoke  GetLastVirtualSection,pMem
    mov     ecx,[eax].IMAGE_SECTION_HEADER.VirtualAddress
    add     ecx,[eax].IMAGE_SECTION_HEADER.Misc.VirtualSize
    invoke  AlignUp,ecx,[edi].IMAGE_NT_HEADERS.OptionalHeader.SectionAlignment
    set     LastVA,eax
    .if dwIcons
        invoke  GetRes,pMem
        mov     eax,lpIcon
        add     eax,pRes
        mov     edi,dpt [eax]
        add     edi,pMem
        m2m     dpt [eax],IconVA
        mov     ecx,dpt [eax+4]
        xor     eax,eax
        rep     stosb
    .endif

    invoke  SectionsWorks,pMem,ofs PackSection,0

    invoke  SaveMemAsFile,pMem,dwFileSize,lpFileName2
    invoke  VirtualFree,pMem,dwFileSize,MEM_DECOMMIT

    invoke  PERealign,lpFileName2,lpFileName2
    mov     pMem,FUNC(MapFile,lpFileName2,addr dwFileSize)
    mov     lpLoader,FUNC(VirtualAlloc,0,dwExFileSize,MEM_COMMIT,PAGE_READWRITE)
    mov     dwLoaderSize,0
    mov     edi,pMem
    add     edi,[edi+3Ch]

    lea     eax,[edi].IMAGE_NT_HEADERS.OptionalHeader.DataDirectory[(IMAGE_DIR_RESOURCE)].VirtualAddress
    sub     eax,pMem
    add     eax,dpt [@@@@ImageBase]
    mov     dpt [@@@@lpResVA],eax

    mov     eax,LastVA
    .if dwIcons
        push    eax
        mov     [edi].IMAGE_NT_HEADERS.OptionalHeader.DataDirectory[(IMAGE_DIR_RESOURCE)].VirtualAddress,eax
        mov     ecx,dwPtr
        sub     ecx,lpResMem
        mov     [edi].IMAGE_NT_HEADERS.OptionalHeader.DataDirectory[(IMAGE_DIR_RESOURCE)].isize,ecx
        invoke  CopyToLoader,lpResMem,ecx
        push    ecx
        invoke  VirtualFree,lpResMem,dwResSize,MEM_DECOMMIT
        pop     ecx
        pop     eax
        add     eax,ecx
    .endif
    .if bTLS
        mov     [edi].IMAGE_NT_HEADERS.OptionalHeader.DataDirectory[(IMAGE_DIR_TLS)].VirtualAddress,eax
        add     eax,dpt [@@@@ImageBase]
        mov     dpt [@@@@TLSVA],eax
        sub     eax,dpt [@@@@ImageBase]
        add     eax,sof TLS_BACKUP
        scall   CopyToLoader,ofs TLS_BACKUP,sof TLS_BACKUP
    .endif
    mov     [edi].IMAGE_NT_HEADERS.OptionalHeader.DataDirectory[(IMAGE_DIR_IMPORT)].VirtualAddress,eax
    push    eax
    mov     ecx,lpLoader
    add     ecx,dwLoaderSize
    invoke  AssembleIT,ecx,eax
    add     dwLoaderSize,eax
    pop     ecx
    mov     [edi].IMAGE_NT_HEADERS.OptionalHeader.DataDirectory[(IMAGE_DIR_IMPORT)].isize,eax
    add     eax,ecx
    mov     [edi].IMAGE_NT_HEADERS.OptionalHeader.AddressOfEntryPoint,eax
    set     EndSectionVA,eax

    lea     eax,[edi].IMAGE_NT_HEADERS.OptionalHeader.SizeOfImage
    sub     eax,pMem
    add     eax,dpt [@@@@ImageBase]
    mov     dpt [@@@@lpSizeOfImage],eax

    scall   CopyToLoader,MAIN,MAINSIZE
    scall   CopyToLoader,VIRTUALPROT,VIRTUALPROTSIZE
    invoke  AddUnpackToLoader,pMem
    invoke  SaveMemAsFile,pMem,dwFileSize,lpFileName2
    scall   CopyToLoader,PROCESSIMPORTS,PROCESSIMPORTSSIZE
    .if dwIcons
        scall   CopyToLoader,RESTORERES,RESTORERESSIZE
    .endif
    scall   CopyToLoader,JMPTOOEP,JMPTOOEPSIZE
    m2m     sAddData.lpFileName,lpFileName2
    m2m     sAddData.lpData,lpLoader
    m2m     sAddData.dwDataSize,dwLoaderSize
    invoke  AddNewSection,addr sAddData

    invoke  VirtualFree,lpLoader,dwExFileSize,MEM_DECOMMIT

    return
PEPack endp

;HHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHH;

MapFile proc lpFileName:DWORD,lpFileSize:DWORD
local hFile:DWORD,pMem:DWORD,SizeRW:DWORD

    mov     hFile,FUNC(CreateFile,lpFileName,GENERIC_READ,FILE_SHARE_READ,0,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,0)
    scall   ShowError,$CT0("Cannot open file"),-1,ofs @ExitProc

    invoke  GetFileSize,hFile,0
    push    eax
    mov     eax,lpFileSize
    pop     dpt [eax]

    mov     pMem,FUNC(VirtualAlloc,0,dpt [eax],MEM_COMMIT,PAGE_READWRITE)
    mov     ecx,lpFileSize
    invoke  ReadFile,hFile,pMem,dpt [ecx],addr SizeRW,0

    @CloseHandle:
    invoke  CloseHandle,hFile
    @ExitProc:
    mov     eax,pMem
    return
MapFile endp

;HHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHH;

PackSection proc lpImage:DWORD,lpSection:DWORD,lParam:DWORD
local lpMem:DWORD,dwSize:DWORD,lpWorkMem:DWORD,dwWorkSize:DWORD,SizeRW:DWORD

    pushad
    mov     esi,lpSection
    assume  esi:ptr IMAGE_SECTION_HEADER
    or      [esi].Characteristics,IMAGE_SCN_MEM_WRITE
    mov     edi,[esi].PointerToRawData
    add     edi,lpImage
    mov     ecx,[esi].SizeOfRawData
    mov     dwSize,ecx
    mov     lpMem,FUNC(VirtualAlloc,0,ecx,MEM_COMMIT,PAGE_READWRITE)
    mov     ecx,dwSize
    mov     esi,lpMem
    xchg    esi,edi
    shr     ecx,2
    push    ecx
    push    esi
    rep     movsd
    xor     eax,eax
    pop     edi
    pop     ecx
    rep     stosd
    mov     esi,lpSection
    assume  esi:nothing
    invoke  GetWorkMemorySize
    mov     dwWorkSize,eax
    mov     lpWorkMem,FUNC(VirtualAlloc,0,eax,MEM_COMMIT,PAGE_READWRITE)
    invoke  Compress,lpMem,dwSize,addr SizeRW,0
    mov     ecx,nSec
    imul    ecx,ecx,sof PACKSEC
    inc     nSec
    add     ecx,ofs PackSections
    mov     [ecx].PACKSEC.lpMem,eax
    m2m     [ecx].PACKSEC.dwSize,dwSize
    m2m     [ecx].PACKSEC.dwTrueSize,SizeRW
    mov     edx,lpSection
    mov     edx,[edx].IMAGE_SECTION_HEADER.VirtualAddress
    add     edx,dpt [@@@@ImageBase]
    mov     [ecx].PACKSEC.lpSec,edx
    invoke  VirtualFree,lpWorkMem,dwWorkSize,MEM_DECOMMIT
    popad

    return
PackSection endp

;HHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHH;

AddUnpackToLoader proc uses ecx eax lpImage:DWORD
    mov     ecx,nSec
@@: mov     eax,ecx
    imul    eax,eax,sof PACKSEC
    add     eax,ofs PackSections - sof PACKSEC
    m2m     dpt [@delta-4],[eax].PACKSEC.dwTrueSize
    m2m     dpt [@@@@VirtualAddress],[eax].PACKSEC.lpSec
    scall   CopyToLoader,UNPACKER1,UNPACKER1SIZE
    scall   CopyToLoader,[eax].PACKSEC.lpMem,[eax].PACKSEC.dwTrueSize
    scall   CopyToLoader,UNPACKER2,UNPACKER2SIZE
    pushad
    invoke  FreeCompressionMemory,[eax].PACKSEC.lpMem
    popad
    dec     ecx
    jnz     @B
    ret
AddUnpackToLoader endp

;HHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHH;

CopyToLoader proc lpData:DWORD,dwSize:DWORD
    pushad
    mov     edi,lpLoader
    add     edi,dwLoaderSize
    mov     esi,lpData
    mov     ecx,dwSize
    add     dwLoaderSize,ecx
    rep     movsb
    popad
    ret
CopyToLoader endp

;HHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHH;

szExitProcess   db "Exit","Process",0
szKernel        db "kernel32.dll",0

AssembleIT proc pAddress4IT:LPVOID, dwNewSectionVA:DWORD
    pushad

    mov     edi,pAddress4IT

    ;-------------------------------------------;
    ; build a new,nice ImportTable :)

    xor     eax,eax
    stosd   ; OriginalFirstThunk
    stosd   ; TimeDateStamp
    stosd   ; ForwarderChain
    mov     eax,dwNewSectionVA
    add     eax,sof IMAGE_IMPORT_DESCRIPTOR * 2 - 4
    stosd   ; Name
    add     eax,sof szKernel
    stosd   ; FirstThunk
    xor     eax,eax
    stosd
    stosd
    stosd
    stosd
;   stosd
    mov     esi,ofs szKernel
    mov     ecx,sof szKernel
    rep     movsb
    mov     eax,IMAGE_ORDINAL_FLAG32 or 1
    stosd   ; ThunkValue
    xor     eax,eax
    stosd   ; ThunkValue
    sub     edi,pAddress4IT
    mov     [esp].PUSHADS.regEax,edi
    popad
    ret
AssembleIT endp

;HHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHH;

MergeSections proc lpFileName1:DWORD,lpFileName2:DWORD
local dwMemSize:DWORD

    set     lpMem,FUNC(MapPEFile,lpFileName1,addr dwMemSize)
    invoke  CorrectSections,lpMem
    mov     edi,lpMem
    add     edi,dpt [edi+3Ch]
    mov     esi,edi
    movzx   eax,wpt [edi].IMAGE_NT_HEADERS.FileHeader.SizeOfOptionalHeader
    lea     edi,[edi + eax].IMAGE_NT_HEADERS.OptionalHeader
    invoke  GetLastVirtualSection,lpMem
    mov     ecx,[eax].IMAGE_SECTION_HEADER.Misc.VirtualSize
    add     ecx,[eax].IMAGE_SECTION_HEADER.VirtualAddress
    invoke  GetFirstVirtualSection,lpMem
    sub     ecx,[eax].IMAGE_SECTION_HEADER.VirtualAddress
    mov     [edi].IMAGE_SECTION_HEADER.Misc.VirtualSize,ecx
    mov     [edi].IMAGE_SECTION_HEADER.SizeOfRawData,ecx
    mov     [eax].IMAGE_SECTION_HEADER.Characteristics,0E00000E0h
    m2m     [edi].IMAGE_SECTION_HEADER.PointerToRawData,[eax].IMAGE_SECTION_HEADER.VirtualAddress
    mov     wpt [esi].IMAGE_NT_HEADERS.FileHeader.NumberOfSections,1
    invoke  SaveMemAsFile,lpMem,dwMemSize,lpFileName2
    invoke  VirtualFree,lpMem,dwMemSize,MEM_DECOMMIT
    return
MergeSections endp

;HHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHH;

EnumResDir proc lpResDir:DWORD
    pushad
    mov     esi,lpResDir
    assume  esi:ptr IMAGE_RESOURCE_DIRECTORY
    movzx   eax,[esi].NumberOfNamedEntries
    movzx   ecx,[esi].NumberOfIdEntries
    add     ecx,eax
    add     esi,sof IMAGE_RESOURCE_DIRECTORY
    assume  esi:ptr IMAGE_RESOURCE_DIRECTORY_ENTRY
@@: mov     eax,[esi].OffsetToData
    .if flagset(eax,80000000h)
        shl     eax,1
        shr     eax,1
        add     eax,pRes
        invoke  EnumResDir,eax
    .else
        mov     edx,[esp+30h]
        mov     edx,[edx].IMAGE_RESOURCE_DIRECTORY_ENTRY.Name1
        .if (edx == RT_ICON)
            inc     dwIcons
            .if !lpIcon
                mov     lpIcon,eax
            .endif
        .elseif (edx == 0Eh)
            .if !lpIconGroup
                mov     lpIconGroup,eax
            .endif
        .endif
    .endif
    add     esi,sof IMAGE_RESOURCE_DIRECTORY_ENTRY
    dec     ecx
    jnz     @B
    assume  esi:nothing
    popad
    ret
EnumResDir endp

;HHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHH;

GetRes proc pMem:DWORD

    mov     lpResMem,FUNC(VirtualAlloc,0,dwResSize,MEM_COMMIT,PAGE_READWRITE)
    mov     dwPtr,eax

        xor     esi,esi
        mov     tmpirdir.NumberOfIdEntries,2
        invoke  CopyToResMem,ofs tmpirdir,sof IMAGE_RESOURCE_DIRECTORY
        or      esi,80000000h
        add     esi,sof IMAGE_RESOURCE_DIRECTORY + (sof IMAGE_RESOURCE_DIRECTORY_ENTRY * 2)
        mov     tmpirdire.OffsetToData,esi
        mov     tmpirdire.Name1,RT_ICON
        invoke  CopyToResMem,ofs tmpirdire,sof IMAGE_RESOURCE_DIRECTORY_ENTRY
        mov     tmpirdire.Name1,0Eh
        add     esi,(sof IMAGE_RESOURCE_DIRECTORY + sof IMAGE_RESOURCE_DIRECTORY_ENTRY) * 2
        mov     tmpirdire.OffsetToData,esi
        invoke  CopyToResMem,ofs tmpirdire,sof IMAGE_RESOURCE_DIRECTORY_ENTRY

        mov     tmpirdir.NumberOfIdEntries,1
        invoke  CopyToResMem,ofs tmpirdir,sof IMAGE_RESOURCE_DIRECTORY
        sub     esi,(sof IMAGE_RESOURCE_DIRECTORY + sof IMAGE_RESOURCE_DIRECTORY_ENTRY)
        mov     tmpirdire.OffsetToData,esi
        mov     tmpirdire.Name1,1
        invoke  CopyToResMem,ofs tmpirdire,sof IMAGE_RESOURCE_DIRECTORY_ENTRY

        mov     tmpirdir.NumberOfIdEntries,1
        invoke  CopyToResMem,ofs tmpirdir,sof IMAGE_RESOURCE_DIRECTORY
        add     esi,(sof IMAGE_RESOURCE_DIRECTORY + sof IMAGE_RESOURCE_DIRECTORY_ENTRY) * 3
        and     esi,not 80000000h
        mov     tmpirdire.OffsetToData,esi
        mov     tmpirdire.Name1,409h
        invoke  CopyToResMem,ofs tmpirdire,sof IMAGE_RESOURCE_DIRECTORY_ENTRY

        invoke  CopyToResMem,ofs tmpirdir,sof IMAGE_RESOURCE_DIRECTORY
        or      esi,80000000h
        sub     esi,(sof IMAGE_RESOURCE_DIRECTORY + sof IMAGE_RESOURCE_DIRECTORY_ENTRY)
        mov     tmpirdire.OffsetToData,esi
        mov     tmpirdire.Name1,1
        invoke  CopyToResMem,ofs tmpirdire,sof IMAGE_RESOURCE_DIRECTORY_ENTRY

        invoke  CopyToResMem,ofs tmpirdir,sof IMAGE_RESOURCE_DIRECTORY
        add     esi,sof IMAGE_RESOURCE_DATA_ENTRY
        add     esi,(sof IMAGE_RESOURCE_DIRECTORY + sof IMAGE_RESOURCE_DIRECTORY_ENTRY)
        and     esi,not 80000000h
        mov     tmpirdire.OffsetToData,esi
        invoke  CopyToResMem,ofs tmpirdire,sof IMAGE_RESOURCE_DIRECTORY_ENTRY

        add     esi,sof IMAGE_RESOURCE_DATA_ENTRY
        add     esi,LastVA
        mov     tmpirdatae.OffsetToData,esi
        mov     IconVA,esi
        mov     eax,lpIcon
        add     eax,pRes
        mov     eax,[eax+4]
        mov     tmpirdatae.Size1,eax
        add     esi,eax
        invoke  CopyToResMem,ofs tmpirdatae,sof IMAGE_RESOURCE_DATA_ENTRY
        mov     tmpirdatae.OffsetToData,esi
        mov     eax,lpIconGroup
        add     eax,pRes
        mov     eax,14h
        mov     tmpirdatae.Size1,eax
        invoke  CopyToResMem,ofs tmpirdatae,sof IMAGE_RESOURCE_DATA_ENTRY

        mov     eax,lpIcon
        add     eax,pRes
        mov     esi,[eax]
        mov     eax,[eax+4]
        mov     iconsize,eax
        add     esi,pMem
        invoke  CopyToResMem,esi,eax

        mov     eax,14h
        mov     esi,ofs icongroup
        invoke  CopyToResMem,esi,eax

        mov     eax,dwPtr
        sub     eax,lpResMem
        m2m     [edi].IMAGE_NT_HEADERS.OptionalHeader.DataDirectory[(IMAGE_DIR_RESOURCE)].VirtualAddress,LastVA
        mov     [edi].IMAGE_NT_HEADERS.OptionalHeader.DataDirectory[(IMAGE_DIR_RESOURCE)].isize,eax

    return
GetRes endp

;HHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHH;

CopyToResMem proc pMem:DWORD,dwSize:DWORD
    pushad
    mov     esi,pMem
    mov     edi,dwPtr
    mov     ecx,dwSize
    add     dwPtr,ecx
    rep     movsb
    popad
    return
CopyToResMem endp

;HHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHH;

SehHandler PROC C pExcept:DWORD,pFrame:DWORD,pContext:DWORD,pDispatch:DWORD
    mov     eax,pContext
    assume  eax:ptr CONTEXT
    m2m     [eax].regEip,SEH.SaveEip
    m2m     [eax].regEsp,SEH.OrgEsp
    m2m     [eax].regEbp,SEH.OrgEbp
    assume  eax:nothing
    return  ExceptionContinueExecution
SehHandler ENDP

;HHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHH;

ShowError proc lpMessage:DWORD,arg:DWORD,PreExit:DWORD
    .IF eax == arg
        invoke  MessageBox,0,lpMessage,$CT0("ERROR"),MB_ICONERROR
        m2m     dpt [esp+4],PreExit
    .ENDIF
    return
ShowError endp

;HHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHH;

JMPTOOEP equ $
    add     esp,sof unpackerStruc
    popad
    push    80808080h
    @@@@oep equ $ - 4
    retn
JMPTOOEPSIZE equ $ - JMPTOOEP

;-----------------------------------------------------------------------------------------;

MAIN equ $
    pushad
    xor     eax,eax
    lea     ecx,[eax + ((sof unpackerStruc / 4) and 0FFh)]
@@: push    eax
    loop    @B
    mov     ebp,esp
    assume  ebp:ptr unpackerStruc

    assume  fs:nothing
    mov     eax,fs:[eax].TEB.Peb
    js      method_9x
method_nt:
    mov     eax,[eax].PEB.Ldr
    mov     esi,[eax].PEB_LDR_DATA.InInitializationOrderModuleList.Flink
    lodsd
    mov     eax, [eax+8]
    jmp     kernel32_ptr_found
method_9x:
    mov     eax,[eax+034h]
    lea     eax,[eax+07Ch]
    mov     eax,[eax+03Ch]
kernel32_ptr_found:
    mov     [ebp].dwKernelBase,eax

    call    GetCallApi
searchapi:
; in  ebx: kernel base
; in  eax: hash
; out eax: address
    pushad
    mov     ebx,[ebp].dwKernelBase
    mov     esi,dpt [ebx+03Ch]
    mov     esi,dpt [esi+ebx+078h]
    add     esi,ebx
    push    esi
    mov     esi,dpt [esi+020h]
    add     esi,ebx
    xor     ecx,ecx
    dec     ecx
    xchg    eax,edx

find_start:
    inc     ecx
    lodsd
    add     eax,ebx

    push    edx
    xor     edi,edi
hash_loop:
    movzx   edx,bpt [eax]
    cmp     dl,dh
    jz      short find_addr
    ror     edi,HASH_KEY
    add     edi,edx
    inc     eax
    jmp     short hash_loop
find_addr:
    pop     edx
    cmp     edi,edx

    jnz     short find_start
    pop     esi
    mov     eax,dpt [esi+024h]
    add     eax,ebx
    mov     cx,wpt [eax+ecx*2]
    mov     edx,dpt [esi+01Ch]
    add     edx,ebx
    mov     eax,dpt [edx+ecx*4]
    add     eax,ebx
    mov     [esp].PUSHADS.regEax,eax
    popad
    jmp     eax

ProcUnpack:
    pushad
    mov     esi,30736h*4
    xor     ebx,ebx
    mov     bh,10h

    push    PAGE_READWRITE
    push    ebx ; MEM_COMMIT
    push    esi
    push    0
    mov     eax,hash("Virtual\Alloc")
    call    [ebp].procCallApi

    shl     ebx,2
    push    ebx ; MEM_DECOMMIT
    push    esi
    push    eax

    push    eax
    push    [esp + 24 + sof PUSHADS]
    push    [esp + 24 + sof PUSHADS]
    call    Unpack

    mov     eax,hash("Virtual\Free")
    call    [ebp].procCallApi

    popad
    retn    4*2

Unpack:
    include unpack.asm

GetCallApi:
    pop     esi
    mov     [ebp].procCallApi,esi
;   add     esi,ofs ProcUnpack - ofs searchapi
    db      083h,0C6h
    db      (ofs ProcUnpack - ofs searchapi)

    mov     [ebp].dwImageBase,80808080h
    @@@@ImageBase equ $ - 4
MAINSIZE equ $ - MAIN

;-----------------------------------------------------------------------------------------;

PROCESSIMPORTS equ $
    mov     esi,80808080h
    @@@@ImportDerectoryVA equ $ - 4 ; + ImageBase

    assume  esi:ptr IMAGE_IMPORT_DESCRIPTOR

;--------------------------------------------------;

@while1:
    mov     ecx,[esi].Name1
    jecxz   @endproc
    add     ecx,[ebp].dwImageBase
    push    ecx
    mov     eax,hash("Load\LibraryA")
    call    [ebp].procCallApi
@@: mov     [ebp].hDLL,eax

;--------------------------------------------------;

    mov     edi,[esi].FirstThunk
    mov     eax,[ebp].dwImageBase
    mov     ecx,[esi].OriginalFirstThunk
    test    ecx,ecx
    jnz     @F
    mov     ecx,edi
    jecxz   @endproc
    @@:

    lea     ebx,[ecx+eax]
    add     edi,eax

;--------------------------------------------------;

@while2:
    mov     ecx,[ebx]
    jecxz   @endw
    inc     ecx
    js      @ordinal

    add     ecx,[ebp].dwImageBase
    jmp     @noneordinal

;--------------------------------------------------;

@ordinal:
    movzx   ecx,wpt [ebx]
    jmp     GetProc

;--------------------------------------------------;

@noneordinal:
    inc     ecx
GetProc:
    push    ecx
    push    [ebp].hDLL
    mov     eax,hash("Get\ProcAddress")
    call    [ebp].procCallApi
    stosd

;--------------------------------------------------;

    test    eax,eax
    je      @endproc
    add     ebx,4
    jmp     @while2

;--------------------------------------------------;

@endw:
    add     esi,sof IMAGE_IMPORT_DESCRIPTOR
    cmp     esi,80808080h
    @@@@ImportDerectorySIZE equ $ - 4
    jb      @while1

@endproc:

PROCESSIMPORTSSIZE equ $ - PROCESSIMPORTS

;-----------------------------------------------------------------------------------------;

UNPACKER1 equ $
    call    @delta
@delta:
UNPACKER1SIZE equ $ - UNPACKER1

UNPACKER2 equ $
    push    401000h
    @@@@VirtualAddress equ $ - 4
    call    esi
UNPACKER2SIZE equ $ - UNPACKER2

;-----------------------------------------------------------------------------------------;

VIRTUALPROT equ $
    push    eax
    push    esp
    push    PAGE_EXECUTE_READWRITE
    push    dpt ds:[80808080h]
    @@@@lpSizeOfImage equ $ - 4
    push    [ebp].dwImageBase
    mov     eax,hash("Virtual\Protect")
    call    [ebp].procCallApi
    pop     eax
VIRTUALPROTSIZE equ $ - VIRTUALPROT

;-----------------------------------------------------------------------------------------;

TLSWORKS equ $
    mov     eax,dpt ds:[80808080h]
    @@@@TLSVA equ $ - 4
    and     dpt [eax],0
TLSWORKSSIZE equ $ - TLSWORKS

;-----------------------------------------------------------------------------------------;

RESTORERES equ $
    mov     edi,80808080h
    @@@@lpResVA equ $ - 4
    mov     eax,80808080h
    @@@@ResVA equ $ - 4
    stosd
    mov     eax,80808080h
    @@@@ResSIZE equ $ - 4
    stosd
RESTORERESSIZE equ $ - RESTORERES

;-----------------------------------------------------------------------------------------;

PROCESSRELOCS equ $
    mov     edi,80808080h
    @@@@BaseRelocVA equ $ - 4
    mov     [ebp].lpRelocs,edi

@while21:
    mov     eax,edi
    sub     eax,[ebp].lpRelocs
    cmp     eax,80808080h
    @@@@BaseRelocSIZE equ $ - 4
    jae     @exitproc
    assume  edi:ptr IMAGE_BASE_RELOCATION
    mov     eax,[edi].SizeOfBlock
    sub     eax,sof IMAGE_BASE_RELOCATION
    shr     eax,1
    mov     [ebp].dwModCount,eax
    lea     edx,[edi+sof IMAGE_BASE_RELOCATION]
    xor     ecx,ecx

@while22:
    inc     ecx
    test    dpt [edx],0F000h
    je      @F
    mov     eax,dpt [edx]
    and     eax,0FFFh
    add     eax,[edi].VirtualAddress
    add     eax,[ebp].dwImageBase
    mov     ebx,[ebp].dwImageBaseDelta

    sub     dpt [eax],ebx
@@: inc     edx
    inc     edx
    cmp     ecx,[ebp].dwModCount
    jb      @while22

    mov     edi,edx
    jmp     @while21
@exitproc:
PROCESSRELOCSSIZE equ $ - PROCESSRELOCS

;HHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHH;

unpackerStruc STRUC
    dwImageBase         dd ?
    dwKernelBase        dd ?
    hDLL                dd ?
    procCallApi         dd ?
    dwImageBaseDelta    dd ?
    lpRelocs            dd ?
    dwModCount          dd ?
unpackerStruc ENDS

;HHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHH;

end start

;HHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHH;

;:end
;@echo off
;set cmpl=\masm32\
;set proj=%~n0
;rem %cmpl%\bin\RC usar.rc
;%cmpl%\bin\ml /nologo /c /coff /Cp /Sa /w /Sp16000 /I%cmpl%\include\ %proj%.bat
;%cmpl%\bin\link /SUBSYSTEM:WINDOWS /LIBPATH:%cmpl%\lib /SECTION:.text,RWE %proj%.obj
;rem del %proj%.obj

;rem HHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHH;
