; #########################################################################

    ; --------------------------------------
    ; This procedure was written by UsAr
    ; --------------------------------------

      .586
      .model flat, stdcall  ; 32 bit memory model
      option casemap :none  ; case sensitive

      include   windows.inc
      include   my.mac
      include_  kernel32
      include   mylib.inc

    freadaddr macro handle,pointer,lpbuff,dwsize
    xpush   ecx,edx,eax
    invoke  SetFilePointer,handle,pointer,0,FILE_BEGIN
    xpop    eax,edx,ecx
    invoke  ReadFile,handle,lpbuff,dwsize,addr SizeRW,0
    endm

    .code

; #########################################################################

MapPEFile proc lpFileName:DWORD,lpFileSize:DWORD
local hFile:DWORD
local dwBuffer:DWORD
local dwMemSize:DWORD
local pMem:DWORD
local FileAlignment:DWORD
local SectionAlignment:DWORD
local SizeRW:DWORD
local lpCurrentSection:DWORD
local lpHeaders:DWORD

    mov     hFile,FUNC(CreateFile,lpFileName,GENERIC_READ,FILE_SHARE_READ,0,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,0)
    iff     ofs @ExitProc

    freadaddr hFile,03Ch,addr dwBuffer,4

    mov     esi,dwBuffer
    lea     esi,[esi].IMAGE_NT_HEADERS.OptionalHeader.SizeOfHeaders
    freadaddr hFile,esi,addr dwBuffer,4
    mov     esi,dwBuffer
    and     esi,0FFFFh
    mov     lpHeaders,FUNC(GlobalAlloc,GMEM_FIXED or GMEM_ZEROINIT,esi)
    freadaddr hFile,0,lpHeaders,esi
    mov     edi,lpHeaders
    add     edi,[edi+03Ch]
    m2m     dwMemSize,[edi].IMAGE_NT_HEADERS.OptionalHeader.SizeOfImage
    movp    lpFileSize,dwMemSize

    mov     pMem,FUNC(VirtualAlloc,0,dwMemSize,MEM_RESERVE or MEM_COMMIT,PAGE_READWRITE)
    mov     ecx,esi
    shr     ecx,2
    mov     edi,pMem
    mov     esi,lpHeaders
    rep     movsd
    invoke  GlobalFree,lpHeaders

    mov     edi,pMem
    add     edi,[edi].IMAGE_DOS_HEADER.e_lfanew
    m2m     FileAlignment,[edi].IMAGE_NT_HEADERS.OptionalHeader.FileAlignment
    m2m     SectionAlignment,[edi].IMAGE_NT_HEADERS.OptionalHeader.SectionAlignment

    movzx   eax,wpt [edi].IMAGE_NT_HEADERS.FileHeader.SizeOfOptionalHeader
    movzx   ecx,wpt [edi].IMAGE_NT_HEADERS.FileHeader.NumberOfSections
    lea     esi,[edi + eax].IMAGE_NT_HEADERS.OptionalHeader
    assume  esi:ptr IMAGE_SECTION_HEADER

    mov     lpCurrentSection,ecx

    SectionsWork:
    dec     lpCurrentSection
    mov     edx,FUNC(AlignDown,[esi].PointerToRawData,FileAlignment)
    mov     ecx,FUNC(AlignUp,[esi].VirtualAddress,SectionAlignment)
    add     ecx,pMem
    mov     ebx,FUNC(AlignUp,[esi].SizeOfRawData,FileAlignment)
    freadaddr hFile,edx,ecx,ebx
    add     esi,sof IMAGE_SECTION_HEADER
    cmp     lpCurrentSection,0
    ja      SectionsWork

    @CloseHandle:
    invoke  CloseHandle,hFile
    @ExitProc:
    mov     eax,pMem
    return
MapPEFile endp

; #########################################################################

end
