; #########################################################################

    ; --------------------------------------
    ; This procedure was written by UsAr
    ; --------------------------------------

      .586
      .model flat, stdcall  ; 32 bit memory model
      option casemap :none  ; case sensitive

      include   windows.inc
      include   my.mac
      include_  kernel32
      include   mylib.inc

    .code

; #########################################################################

MapPEFile2 proc uses ecx edx lpFileName:DWORD
local hFile:DWORD
local hMapping:DWORD
local pMapping:DWORD

    mov     hFile,FUNC(CreateFile,lpFileName,GENERIC_READ,FILE_SHARE_READ,0,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,0)
    iff     ofs @ExitProc

    mov     hMapping,FUNC(CreateFileMapping,hFile,0,PAGE_READONLY or SEC_IMAGE,0,0,0)
    ifz     ofs @FileOpenMappingError

    mov     pMapping,FUNC(MapViewOfFile,hMapping,FILE_MAP_READ,0,0,0)
    ifz     ofs @FileMappingError

    mov     eax,pMapping
    return
@FileMappingError:
    invoke  CloseHandle,hMapping
@FileOpenMappingError:
    invoke  CloseHandle,hFile
@ExitProc:
    return  0
MapPEFile2 endp

; #########################################################################

end
