; #########################################################################

    ; --------------------------------------
    ; This procedure was written by UsAr
    ; --------------------------------------

      .586
      .model flat, stdcall  ; 32 bit memory model
      option casemap :none  ; case sensitive

      include   windows.inc
      include   my.mac
      include_  kernel32
;     include   AlignUp.asm
      include   mylib.inc

    .code

jeaxe MACRO arg1,arg2
    cmp     eax,arg1
    jz      arg2
ENDM

jeaxne MACRO arg1,arg2
    cmp     eax,arg1
    jnz     arg2
ENDM

; #########################################################################

stub    db 04Dh,05Ah,040h,000h,001h,000h,000h,000h,002h,000h,004h,000h,0FFh,0FFh,002h,000h
        db 040h,000h,000h,000h,00Eh,000h,000h,000h,01Ch,000h,000h,000h,000h,000h,000h,000h
        db 028h,063h,029h,020h,055h,073h,041h,072h,020h,032h,06Fh,06Fh,036h,024h,00Eh,0B4h
        db 009h,0BAh,000h,000h,01Fh,0CDh,021h,0B8h,001h,04Ch,0CDh,021h,040h,000h,000h,000h
stubsize equ $ - stub

PERealign proc fileName1:DWORD, fileName2:DWORD
local dwFileSize:DWORD
local pMapping:DWORD
local hMapping:DWORD
local hFile1:DWORD
local hFile2:DWORD
local SizeRW:DWORD
local lpMem1:DWORD
local lpMem2:DWORD
local dwNewFileSize:DWORD
local dwSPos:DWORD
local FileAlignment:DWORD
local SectionAlignment:DWORD

    xor     ebx,ebx
    ;=====================================================================================;
    mov     hFile1,FUNC(CreateFile,fileName1,GENERIC_READ,FILE_SHARE_READ,ebx,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,ebx)
    iff     ofs @EndProc

    mov     dwFileSize,FUNC(GetFileSize,hFile1,ebx)
    mov     pMapping,FUNC(VirtualAlloc,0,dwFileSize,MEM_COMMIT,PAGE_READWRITE)
    ifz     ofs @CloseHandle1

    invoke  ReadFile,hFile1,pMapping,dwFileSize,addr SizeRW,0
    invoke  CloseHandle,hFile1
    ;=====================================================================================;

    mov     edi,pMapping
    add     edi,dpt [edi+3ch]
    assume  edi:ptr IMAGE_NT_HEADERS
;    .if ([edi].OptionalHeader.SectionAlignment < 4096) || ([edi].OptionalHeader.FileAlignment < 512)
;        jmp     ofs @UnmapViewOfFile
;    .endif

    mov     hFile2,FUNC(CreateFile,fileName2,GENERIC_WRITE,ebx,ebx,CREATE_ALWAYS,ebx,ebx)
    iff     ofs @UnmapViewOfFile

    mov     ecx,pMapping
    .if dpt [ecx+3ch] >= stubsize
        invoke  WriteFile,hFile2,ofs stub,stubsize,addr SizeRW,0
    .else
        invoke  WriteFile,hFile2,pMapping,[ecx+3Ch],addr SizeRW,0
    .endif
    mov     eax,SizeRW
    mov     dwNewFileSize,eax
    mov     lpMem1,FUNC(GlobalAlloc,GMEM_FIXED or GMEM_ZEROINIT,sof IMAGE_NT_HEADERS)
    pushad
    mov     ecx,sof IMAGE_NT_HEADERS / 4
    mov     esi,edi
    mov     edi,lpMem1
    rep     movsd
    popad
    mov     esi,lpMem1
    assume  esi:ptr IMAGE_NT_HEADERS
    mov     [esi].OptionalHeader.FileAlignment,512
;   mov     [esi].OptionalHeader.SectionAlignment,1000h
;   mov     [esi].OptionalHeader.FileAlignment,64
    mov     [esi].OptionalHeader.CheckSum,0
    mov     [esi].OptionalHeader.DataDirectory[(IMAGE_DIR_BOUND_IMPORT)].isize,0
    mov     [esi].OptionalHeader.DataDirectory[(IMAGE_DIR_BOUND_IMPORT)].VirtualAddress,0
    m2m     FileAlignment,[esi].OptionalHeader.FileAlignment
    m2m     SectionAlignment,[esi].OptionalHeader.SectionAlignment

    movzx   eax,[esi].FileHeader.NumberOfSections
    imul    eax,eax,sof IMAGE_SECTION_HEADER
    add     eax,stubsize + sof IMAGE_FILE_HEADER + 4
    movzx   ecx,wpt [esi].FileHeader.SizeOfOptionalHeader
    add     eax,ecx
    invoke  AlignUp,eax,dpt [esi].OptionalHeader.FileAlignment
    mov     [esi].OptionalHeader.SizeOfHeaders,eax
    mov     dwSPos,eax

    movzx   eax,[esi].FileHeader.NumberOfSections
    imul    eax,eax,sof IMAGE_SECTION_HEADER
    push    eax
    mov     lpMem2,FUNC(GlobalAlloc,GMEM_FIXED or GMEM_ZEROINIT,eax)
    movzx   eax,wpt [edi].FileHeader.SizeOfOptionalHeader
    lea     eax,[edi + eax].OptionalHeader
    pop     ecx
    pushad
    shr     ecx,2
    mov     esi,eax
    mov     edi,lpMem2
    rep     movsd
    popad

    mov     edi,lpMem2
    assume  edi:ptr IMAGE_SECTION_HEADER
    movzx   ecx,[esi].FileHeader.NumberOfSections
@NextSection:
    .if [edi].SizeOfRawData
        mov     eax,[edi].SizeOfRawData
        add     eax,[edi].PointerToRawData
        add     eax,pMapping
    @@: sub     eax,pMapping
        cmp     eax,[edi].PointerToRawData
        jz      @F
        add     eax,pMapping
        dec     eax
        cmp     bpt [eax],0
        jz      @B

        inc     eax
        sub     eax,pMapping
    @@: sub     eax,[edi].PointerToRawData
        invoke  AlignUp,eax,[esi].OptionalHeader.FileAlignment
        cmp     eax,[edi].SizeOfRawData
        jz      @F
        mov     [edi].SizeOfRawData,eax
    .endif
    m2m     [edi].PointerToRawData,dwSPos
    mov     eax,[edi].SizeOfRawData
    add     dwSPos,eax
    add     edi,sof IMAGE_SECTION_HEADER
    loop    @NextSection

    movzx   ecx,wpt [esi].FileHeader.SizeOfOptionalHeader
    add     ecx,sof IMAGE_FILE_HEADER + 4
    invoke  WriteFile,hFile2,lpMem1,ecx,addr SizeRW,0
    mov     eax,SizeRW
    add     dwNewFileSize,eax
    sub     edi,lpMem2
    invoke  WriteFile,hFile2,lpMem2,edi,addr SizeRW,0
    mov     eax,SizeRW
    add     dwNewFileSize,eax
    mov     esi,[esi].OptionalHeader.SizeOfHeaders
    sub     esi,dwNewFileSize
    test    esi,esi
    jz      @F
    invoke  GlobalAlloc,GMEM_FIXED or GMEM_ZEROINIT,esi
    push    eax
    mov     ecx,eax
    invoke  WriteFile,hFile2,ecx,esi,addr SizeRW,0
    call    GlobalFree
@@: mov     edi,lpMem2
    mov     ebx,lpMem1
    mov     esi,pMapping
    add     esi,dpt [esi+3ch]
    movzx   eax,wpt [esi].FileHeader.SizeOfOptionalHeader
    lea     esi,[esi + eax].OptionalHeader
    assume  esi:ptr IMAGE_SECTION_HEADER
    movzx   ebx,[ebx].IMAGE_NT_HEADERS.FileHeader.NumberOfSections
@@: .if [edi].SizeOfRawData
        mov     edx,pMapping
        add     edx,[esi].PointerToRawData
        invoke  WriteFile,hFile2,edx,[edi].SizeOfRawData,addr SizeRW,0
    .endif
    add     edi,sof IMAGE_SECTION_HEADER
    add     esi,sof IMAGE_SECTION_HEADER
    dec     ebx
    jnz     @B

    invoke  GlobalFree,lpMem1
    invoke  GlobalFree,lpMem2

@UnmapViewOfFile:
    invoke  VirtualFree,pMapping,dwFileSize,MEM_DECOMMIT
@CloseHandle2:
    invoke  CloseHandle,hFile2

@EndProc:
    return

@CloseHandle1:
    invoke  CloseHandle,hFile1
    jmp     @EndProc
PERealign endp

; #########################################################################

end
