; #########################################################################

    ; --------------------------------------
    ; This procedure was written by UsAr
    ; --------------------------------------

      .586
      .model flat, stdcall  ; 32 bit memory model
      option casemap :none  ; case sensitive

      include   windows.inc
      include   my.mac
      include   mylib.inc
      include_  imagehlp

    .code

; #########################################################################

RVA2Offset proc uses ebx ecx edx, Base:DWORD,dwITRVA:DWORD
local FileAlignment:DWORD,SectionAlignment:DWORD
; calulates the Offset from a RVA
; Base    - base of the MMF
; dwITRVA - the RVA to calculate
; returns 0 if an error occurred else the calculated Offset will be returned

    ; get the pointer to the NT header
    mov     eax,Base
    add     eax,[eax+03Ch]
    m2m     FileAlignment,[eax].IMAGE_NT_HEADERS.OptionalHeader.FileAlignment
    m2m     SectionAlignment,[eax].IMAGE_NT_HEADERS.OptionalHeader.SectionAlignment

    .IF FUNC(ImageRvaToSection,eax,Base,dwITRVA)
        xchg    eax,ebx
        assume  ebx:ptr IMAGE_SECTION_HEADER
        mov     ecx,dwITRVA
        invoke  AlignDown,[ebx].VirtualAddress,SectionAlignment
        sub     ecx,eax
        invoke  AlignUp,[ebx].PointerToRawData,FileAlignment
        add     ecx,eax
        assume  ebx:nothing
        xchg    ecx,eax
    .ENDIF

    ret
RVA2Offset endp

; #########################################################################

end
