; #########################################################################

    ; --------------------------------------
    ; This procedure was written by UsAr
    ; --------------------------------------

      .586
      .model flat, stdcall  ; 32 bit memory model
      option casemap :none  ; case sensitive

      include   windows.inc
      include   my.mac
      include_  kernel32
;     include   AlignUp.asm
      include   mylib.inc

    .code

; #########################################################################

UseOverley proc uses esi ecx edx edi fileName1:DWORD
local pMapping:DWORD
local hMapping:DWORD
local hFile:DWORD

    mov     hFile,FUNC(CreateFile,fileName1,GENERIC_READ or GENERIC_WRITE,FILE_SHARE_READ,0,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,0)
    iff     ofs @ExitProc

    mov     hMapping,FUNC(CreateFileMapping,hFile,0,PAGE_READWRITE,0,0,0)
    ifz     ofs @FileOpenMappingError

    mov     pMapping,FUNC(MapViewOfFile,hMapping,FILE_MAP_READ or FILE_MAP_WRITE,0,0,0)
    ifz     ofs @FileMappingError

    mov     esi,pMapping
    add     esi,dpt [esi+3Ch]
    invoke  GetLastPhisicalSection,pMapping
    mov     edi,eax
    mov     eax,[edi].IMAGE_SECTION_HEADER.PointerToRawData
;   invoke  AlignDown,[edi].IMAGE_SECTION_HEADER.PointerToRawData,[esi].IMAGE_NT_HEADERS.OptionalHeader.FileAlignment
    mov     ecx,eax
    mov     eax,[edi].IMAGE_SECTION_HEADER.SizeOfRawData
;   invoke  AlignUp,[edi].IMAGE_SECTION_HEADER.SizeOfRawData,[esi].IMAGE_NT_HEADERS.OptionalHeader.FileAlignment
    add     eax,ecx
    push    eax
    invoke  GetFileSize,hFile,0
    pop     ecx
    sub     eax,ecx
    add     [edi].IMAGE_SECTION_HEADER.SizeOfRawData,eax
    mov     esi,eax

@UnmapViewOfFile:
    invoke  UnmapViewOfFile,pMapping
@FileMappingError:
    invoke  CloseHandle,hMapping
@FileOpenMappingError:
    invoke  CloseHandle,hFile
@ExitProc:
    mov     eax,esi
    return

UseOverley endp

; #########################################################################

end
